#  core sql file

#
# Table structure for table `blanks`
#

DROP TABLE IF EXISTS blanks;
CREATE TABLE blanks (
  id_blank int(11) NOT NULL auto_increment,
  name varchar(250) NOT NULL default '',
  blank varchar(250) NOT NULL default '',
  date_ date NOT NULL default '0000-00-00',
  comments text,
  user_id int(11) NOT NULL default '0',
  day_finish date default NULL,
  day_last date default '0000-00-00',
  period_month int(2) default NULL,
  PRIMARY KEY  (id_blank)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `debtors`
#

DROP TABLE IF EXISTS debtors;
CREATE TABLE debtors (
  id_debtor int(11) NOT NULL auto_increment,
  id_blank int(11) NOT NULL default '0',
  id_organization int(11) NOT NULL default '0',
  date_last date NOT NULL default '0000-00-00',
  date_update date NOT NULL default '0000-00-00',
  PRIMARY KEY  (id_debtor)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `dict_area`
#

DROP TABLE IF EXISTS dict_area;
CREATE TABLE dict_area (
  _id int(10) NOT NULL auto_increment,
  _name varchar(150) NOT NULL default '',
  PRIMARY KEY  (_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `dict_city`
#

DROP TABLE IF EXISTS dict_city;
CREATE TABLE dict_city (
  _id int(10) NOT NULL auto_increment,
  _name varchar(150) NOT NULL default '',
  PRIMARY KEY  (_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `dict_country`
#

DROP TABLE IF EXISTS dict_country;
CREATE TABLE dict_country (
  _id int(10) NOT NULL auto_increment,
  _name varchar(150) NOT NULL default '',
  PRIMARY KEY  (_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `dict_levels`
#

DROP TABLE IF EXISTS dict_levels;
CREATE TABLE dict_levels (
  _id int(8) NOT NULL auto_increment,
  _name varchar(55) NOT NULL default '',
  PRIMARY KEY  (_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `dict_priority`
#

DROP TABLE IF EXISTS dict_priority;
CREATE TABLE dict_priority (
  _id int(10) NOT NULL auto_increment,
  _name varchar(150) NOT NULL default '',
  pri_color varchar(10) NOT NULL default '',
  PRIMARY KEY  (_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `dict_region`
#

DROP TABLE IF EXISTS dict_region;
CREATE TABLE dict_region (
  _id int(10) NOT NULL auto_increment,
  _name varchar(150) NOT NULL default '',
  PRIMARY KEY  (_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `form_blocks`
#

DROP TABLE IF EXISTS form_blocks;
CREATE TABLE form_blocks (
  id_blank int(10) NOT NULL default '0',
  id_result int(10) NOT NULL default '0',
  date_ datetime NOT NULL default '0000-00-00 00:00:00'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `form_fields`
#

DROP TABLE IF EXISTS form_fields;
CREATE TABLE form_fields (
  id int(10) NOT NULL auto_increment,
  id_blank int(10) NOT NULL default '0',
  num varchar(250) NOT NULL default '',
  field varchar(250) NOT NULL default '',
  PRIMARY KEY  (id),
  UNIQUE KEY tt3 (id_blank,field)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `form_organization`
#

DROP TABLE IF EXISTS form_organization;
CREATE TABLE form_organization (
  id_blank int(10) NOT NULL default '0',
  organization_id int(10) NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `form_values`
#

DROP TABLE IF EXISTS form_values;
CREATE TABLE form_values (
  id int(10) NOT NULL auto_increment,
  id_form int(10) NOT NULL default '0',
  id_blank int(10) NOT NULL default '0',
  field varchar(50) NOT NULL default '',
  field_value varchar(250) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `forms`
#

DROP TABLE IF EXISTS forms;
CREATE TABLE forms (
  id int(10) NOT NULL auto_increment,
  id_blank int(11) NOT NULL default '0',
  name varchar(250) NOT NULL default '',
  blank varchar(250) NOT NULL default '',
  date_ date NOT NULL default '0000-00-00',
  date_update date NOT NULL default '0000-00-00',
  comments text,
  user_id int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `global_variables`
#

DROP TABLE IF EXISTS global_variables;
CREATE TABLE global_variables (
  id int(10) NOT NULL auto_increment,
  field varchar(20) NOT NULL default '',
  field_name varchar(150) NOT NULL default '',
  query text NOT NULL,
  description varchar(250) NOT NULL default '',
  connection_name varchar(10) default NULL,
  user_id int(10) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY un_var (field)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `link_organizations`
#

DROP TABLE IF EXISTS link_organizations;
CREATE TABLE link_organizations (
  link_id int(10) NOT NULL default '0',
  organization_id int(10) NOT NULL default '0',
  UNIQUE KEY u_o (link_id,organization_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `links`
#

DROP TABLE IF EXISTS links;
CREATE TABLE links (
  link_id int(10) unsigned NOT NULL auto_increment,
  link_name varchar(100) NOT NULL default '',
  link_url varchar(200) NOT NULL default '',
  link_description text,
  link_parent int(10) default '0',
  link_order int(10) default '0',
  link_open varchar(20) default NULL,
  link_unvisible int(1) default '0',
  link_language varchar(50) NOT NULL default 'English',
  PRIMARY KEY  (link_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `news`
#

DROP TABLE IF EXISTS news;
CREATE TABLE news (
  news_id int(8) unsigned NOT NULL auto_increment,
  user_id int(8) unsigned NOT NULL default '0',
  news_date datetime NOT NULL default '0000-00-00 00:00:00',
  news_head varchar(55) NOT NULL default '',
  news_body text NOT NULL,
  PRIMARY KEY  (news_id),
  UNIQUE KEY news_id (news_id),
  KEY news_id_2 (news_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `organization`
#

DROP TABLE IF EXISTS organization;
CREATE TABLE organization (
  id int(10) NOT NULL auto_increment,
  name varchar(200) NOT NULL default '',
  id_country int(10) default NULL,
  id_city int(10) default NULL,
  id_area int(10) default NULL,
  id_region int(10) default NULL,
  address varchar(200) default NULL,
  phone varchar(100) default NULL,
  email varchar(100) default NULL,
  contact1 varchar(100) default NULL,
  contact2 varchar(100) default NULL,
  comment varchar(250) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `organization_levels`
#

DROP TABLE IF EXISTS organization_levels;
CREATE TABLE organization_levels (
  organization_main int(10) NOT NULL default '0',
  organization_ancillary int(10) NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `users`
#

DROP TABLE IF EXISTS users;
CREATE TABLE users (
  user_id int(8) unsigned NOT NULL auto_increment,
  user_name varchar(55) NOT NULL default '',
  user_pass varchar(55) NOT NULL default '',
  user_sess varchar(150) default NULL,
  user_level int(8) unsigned default '0',
  user_organization int(8) unsigned NOT NULL default '0',
  r_name varchar(200) default NULL,
  phone varchar(100) default NULL,
  mobile varchar(100) default NULL,
  email varchar(100) default NULL,
  post varchar(250) default NULL,
  PRIMARY KEY  (user_id),
  UNIQUE KEY user_id (user_name),
  KEY user_id_2 (user_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `users_mail_stat`
#

DROP TABLE IF EXISTS users_mail_stat;
CREATE TABLE users_mail_stat (
  user_id int(8) unsigned NOT NULL default '0',
  id_blank int(10) NOT NULL default '0',
  stat_action varchar(50) NOT NULL default '',
  stat_result varchar(200) NOT NULL default '',
  stat_date datetime NOT NULL default '0000-00-00 00:00:00'
) TYPE=MyISAM;

DROP TABLE IF EXISTS ex_variables;
CREATE TABLE ex_variables (
  id int(10) NOT NULL default '0'
) TYPE=MyISAM;

