<?
/********************************************************
	include/pop3.inc
//	(C)Copyright 2002-2003 Olga Axyonenko <olga@is.zp.ua>, Mario Altimari <altimario@hotmail.com>
//
//	This file is part of Mentore Portal.
//      See  http://www.mentore.it or  http://www.is.zp.ua

	PURPOSE:
		pop3 library

********************************************************/
$pop3_iil_error;
$pop3_iil_errornum;
$pop3_iil_selected;

class pop3_iilConnection{
	var $fp;
	var $login;
	var $password;
	var $host;
	var $error;
	var $errorNum;
	var $selected;
	var $cacheFP;
	var $cacheMode;
}

class pop3_iilBasicHeader{
	var $id;
	var $uid;
	var $subject;
	var $from;
	var $to;
	var $cc;
	var $replyto;
	var $date;
	var $messageID;
	var $size;
	var $encoding;
	var $flags;
	var $timestamp;
	var $seen;
	var $deleted;
	var $recent;
	var $answered;
}

function pop3_iil_xor($string, $string2){
    $result = "";
    $size = strlen($string);
    for ($i=0; $i<$size; $i++) $result .= chr(ord($string[$i]) ^ ord($string2[$i]));
        
    return $result;
}

function pop3_iil_ReadLine($fp, $size){
	$line="";
	if (($fp)&&(!feof($fp))){
		do{
			$buffer = fgets($fp, 1024);
			$endID = strlen($buffer) - 1;
			$end = (($buffer[$endID] == "\n")||(feof($fp)));
			$line.=$buffer;
		}while(!$end);
	}
	if ((feof($fp)) && (!empty($line))) $line.="\n";
	return $line;
}

function pop3_iil_C_ReadLine(&$conn){
	if ($conn->cacheMode == "x") return pop3_iil_ReadLine($conn->fp, 300);
	else if ($conn->cacheMode == "r"){
		$line = pop3_iil_ReadLine($conn->cacheFP, 300);
		return $line;
	}else if ($conn->cacheMode == "w"){
		$line = pop3_iil_ReadLine($conn->fp, 300);
		fputs($conn->cacheFP, $line);
		return $line;
	}
}

function pop3_iil_ReadReply($fp){
	do{
		$line = chop(trim(pop3_iil_ReadLine($fp, 1024)));
	}while($line[0]=="*");
	
	return $line;
}

function pop3_iil_ParseResult($string){
	$a=explode(" ", $string);
	if (count($a) > 2){
		if (strcasecmp($a[1], "OK")==0) return 0;
		else if (strcasecmp($a[1], "NO")) return -1;
		else if (strcasecmp($a[1], "BAD")) return -2;
	}else return -3;
}

// check if $string starts with $match
function pop3_iil_StartsWith($string, $match){
	if ((empty($string)) || (empty($match))) return false;
	
	if ($string[0]==$match[0]){
		$pos=strpos($string, $match);
		if ( $pos === false) return false;
		else if ( $pos == 0) return true;
		else return false;
	}else{
		return false;
	}
}

function pop3_iil_Close(&$conn){
	if (@fputs($conn->fp, "QUIT\r\n")){
		fgets($conn->fp, 1024);
		fclose($conn->fp);
	}
}

function pop3_iil_Connect($host, $user, $password){	
    global $pop3_iil_error, $pop3_iil_errornum;
	
	$result = false;

	$conn = new pop3_iilConnection;

	$conn->error="";
	$conn->errorNum=0;
	$conn->login = $user;
	$conn->password = $password;
	$conn->host = $host;
	$conn->selected="";
	$conn->fp=fsockopen($host, 110);
	if ($conn->fp){
		$pop3_iil_error.="Socket connection established\r\n";
		$line=pop3_iil_ReadLine($conn->fp, 300);

        fputs($conn->fp, "USER $user\r\n");
        $line = trim(chop(pop3_iil_ReadLine($conn->fp, 1024)));
		if (pop3_iil_StartsWith($line, "+OK")){
			fputs($conn->fp, "PASS $password\r\n");
			$line = trim(chop(pop3_iil_ReadLine($conn->fp, 1024)));
			if (pop3_iil_StartsWith($line, "+OK")){
				$result = true;
				}
			else{
				$pop3_iil_errornum = -11;
				$pop3_iil_error = $line;
				pop3_iil_Close($conn);
				return false;
			}
		}else{
			$pop3_iil_errornum = -2;
			$pop3_iil_error = "Unknown user";
			pop3_iil_Close($conn);
			return false;
		}
    }else{
        $pop3_iil_error = "Could not connect to $host at port 110";
        $pop3_iil_errornum = -1;
		return false;
	}
	
	if ($result) return $conn;
	else return false;
}

function pop3_iil_ExplodeQuotedString($delimiter, $string){
	$quotes=explode("\"", $string);
	while ( list($key, $val) = each($quotes))
		if (($key % 2) == 1) 
			$quotes[$key] = str_replace($delimiter, "_!@!_", $quotes[$key]);
	$string=implode("\"", $quotes);
	
	$result=explode($delimiter, $string);
	while ( list($key, $val) = each($result) )
		$result[$key] = str_replace("_!@!_", $delimiter, $result[$key]);
	
	return $result;
}

function pop3_iil_CheckForRecent($host, $user, $password, $mailbox){
	return 0;
}

function pop3_iil_C_Select(&$conn, $mailbox){
	return true;
}

function pop3_iil_C_CountMessages(&$conn, $mailbox){
	$num=-1;
	$fp = $conn->fp;
	
	if (fputs($fp, "STAT\r\n")){
		$line=chop(fgets($fp, 300));
		$a=explode(" ", $line);
		$num=(int)$a[1];
		$size = (int)$a[2];
	}
	
	return $num;
}

function pop3_iil_SplitHeaderLine($string){
	$pos=strpos($string, ":");
	if ($pos>0){
		$res[0]=substr($string, 0, $pos);
		$res[1]=substr($string, $pos+2);
		return $res;
	}else{
		return $string;
	}
}

function pop3_iil_StrToTime($str){
	$pos=strpos($str, ",");
	if ($pos > 0) $str = trim(substr($str, $pos+1));

	$a=explode(" ",$str);
	$month_a=array("Jan"=>1,"Feb"=>2,"Mar"=>3,"Apr"=>4,"May"=>5,"Jun"=>6,"Jul"=>7,"Aug"=>8,"Sep"=>9,"Oct"=>10,"Nov"=>11,"Dec"=>12);
	$month_str=$a[1];
	$month=$month_a[$month_str];
	$day=$a[0];
	$year=$a[2];
	$time=$a[3];
	$tz_str = $a[4];
	$tz = substr($tz_str, 0, 3);
	$ta=explode(":",$time);
	$hour=(int)$ta[0]-(int)$tz;
	$minute=$ta[1];
	$second=$ta[2];

	return mktime($hour, $minute, $second, $month, $day, $year);
}

function pop3_iil_F_List($fp){
	fputs($fp, "LIST\r\n");
	$line = fgets($fp, 128);
	if ($line[0]=="+"){
		do{
			$line = fgets($fp, 128);
			if ($line[0]!="."){
				$a = explode(" ", $line);
				$id = (int)$a[0];
				$size = (int)$a[1];
				$index[$id] = $size;
			}
		}while($line[0]!=".");
	}
	return $index;
}

function pop3_iil_F_GetMessageID($fp, $id){
	$messageID = "";
	
	fputs($fp, "TOP $id 0\r\n");
	$line = fgets($fp, 128);
	if ($line[0]=="+"){
		do{
			//go through headers...
			$line = chop(pop3_iil_ReadLine($fp, 300));
			$a = pop3_iil_SplitHeaderLine($line);
			if (strcasecmp($a[0], "message-id")==0){
				$messageID = trim(chop($a[1]));
				$messageID = substr(substr($messageID, 1), 0, strlen($messageID)-2);
			}
		}while($line[0]!=".");
	}
	return $messageID;
}

function pop3_iil_C_FetchHeaderIndex(&$conn, $mailbox, $message_set, $index_field){
	return false;
	
	/*
		NOTE:
		Following code is a complete functional implementation of this particular function,
		compatible with it's IMAP equivalence.  Only problem is, with POP3, it's less efficient
		because the entire header for all messages have to be read in. 
	*/

	
	$fp = $conn->fp;
	$result = array();
	$index_field = strtoupper($index_field);
	
	//get index list
	$index = pop3_iil_F_List($fp);

	if (strcmp($index_field, "SIZE")==0){
		return $index;
	}else{
		reset($index);
		//loop through all items
		while ( list($id, $val) = each($index) ){
			//fetch header
			fputs($fp, "TOP $id 0\r\n");
			$line = fgets($fp, 128);
			if ($line[0]=="+"){
				do{
					//go through headers...
					$line = chop(pop3_iil_ReadLine($fp, 300));
					$a = pop3_iil_SplitHeaderLine($line);
					//look for line containg field we want
					if (strcasecmp($index_field,"date")==0) $a[1] = pop3_iil_StrToTime($a[1]);
					if (strcasecmp($a[0], $index_field)==0) $result[$id] = $a[1];
				}while($line[0]!=".");
			}
		}
	}
	
	return $result;
}

function pop3_iil_C_FetchHeaders(&$conn, $mailbox, $message_set){
	if (strpos($message_set, ":")>0){
		$a = explode(":", $message_set);
		$from_i = (int)$a[0];
		$to_i = (int)$a[1];
	}else if (strpos($message_set, ",")>0){
		$a = explode(",", $message_set);
		$n = count($a);
		$from_i = (int)$a[0];
		$to_i = (int)$a[$n-1];
	}else{
		$from_i = $to_i = $message_set;
	}
		
	$fp = $conn->fp;
	$index = pop3_iil_F_List($fp);
	
	$c = 0;
	$lines = array();
	for ($id=$from_i;$id<=$to_i;$id++){
		fputs($fp, "TOP $id 0\r\n");
		$line = fgets($fp, 128);
		if ($line[0]=="+"){

			//initialize new pop3_iilBasicHeader object
			$result[$id] = new pop3_iilBasicHeader;
			$result[$id]->size = $index[$id];
			$result[$id]->id = $id;
			$result[$id]->seen = false;
			$result[$id]->recent = false;
			$result[$id]->deleted = false;
			$result[$id]->answered = false;
			
			//fetch header into array
			do{
				$line = chop(pop3_iil_ReadLine($fp, 300));
				if (strlen($line)>2){
					if (ord($line[0]) <= 32) $lines[$c] = $lines[$c]." ".trim($line);
					else{
						$lines[$c]=$line;
						$c++;
					}
				}
			}while($line[0]!=".");
			
			//process header, fill pop3_iilBasicHeader obj.
			$numlines = count($lines);
			for ($i=0;$i<$numlines;$i++){
				
				list($field, $string) = pop3_iil_SplitHeaderLine($lines[$i]);
				
				if (strcasecmp($field, "date")==0){
					$result[$id]->date=$string;
					$result[$id]->timestamp=pop3_iil_StrToTime($string);
				}
				else if (strcasecmp($field, "from")==0) $result[$id]->from = $string;
				else if (strcasecmp($field, "to")==0) $result[$id]->to = $string;
				else if (strcasecmp($field, "subject")==0) $result[$id]->subject = $string;
				else if (strcasecmp($field, "reply-to")==0) $result[$id]->replyto=$string;
				else if (strcasecmp($field, "cc")==0) $result[$id]->cc=$string;
				else if (strcasecmp($field, "message-id")==0)
					$result[$id]->messageID = substr(substr($string, 1), 0, strlen($string)-2);
				else if (strcasecmp($field, "Content-Transfer-Encoding")==0) $result[$id]->encoding=$string;
			}
		}
	}
	return $result;
}


function pop3_iil_C_FetchHeader(&$conn, $mailbox, $id){

	$fp = $conn->fp;

	$index = pop3_iil_F_List($fp);

	fputs($fp, "TOP $id 0\r\n");
	$line = fgets($fp, 128);
	if ($line[0]=="+"){
		//initialize new pop3_iilBasicHeader object
		$result = new pop3_iilBasicHeader;
		$result->size = $index[$id];
		$result->id = $id;
		
		//fetch header into array
		do{
			$line = chop(pop3_iil_ReadLine($fp, 300));
			if (strlen($line)>2){
				if (ord($line[0]) <= 32) $lines[$c] .= (empty($lines[$c])?"":"\n").trim($line);
				else{
					$c++;
					$lines[$c]=$line;
				}
			}
		}while($line[0]!=".");
		
		//process header, fill pop3_iilBasicHeader obj.
		$numlines = count($lines);
		for ($i=0;$i<$numlines;$i++){
			
			list($field, $string) = pop3_iil_SplitHeaderLine($lines[$i]);
			
			if (strcasecmp($field, "date")==0){
				$result->date = $string;
				$result->timestamp = pop3_iil_StrToTime($string);
			}
			else if (strcasecmp($field, "from")==0) $result->from = str_replace("\n", " ", $string);
			else if (strcasecmp($field, "to")==0) $result->to = $string;
			else if (strcasecmp($field, "subject")==0) $result->subject = str_replace("\n", "", $string);
			else if (strcasecmp($field, "reply-to")==0) $result->replyto=$string;
			else if (strcasecmp($field, "cc")==0) $result->cc = str_replace("\n", " ", $string);
			else if (strcasecmp($field, "Content-Transfer-Encoding")==0) $result->encoding=$string;
			else if (strcasecmp($field, "message-id")==0)
				$result->messageID = substr(substr($string, 1), 0, strlen($string)-2);
		}
		return $result;
	}else{
		return false;
	}
	/*
	$a=pop3_iil_C_FetchHeaders($conn, $mailbox, $id);
	if (is_array($a)) return $a[$id];
	else return false;
	*/

}


function pop3_iil_SortHeaders($a, $field, $flag){
	if (empty($field)) $field="uid";
	$field=strtolower($field);
	if ($field=="date") $field="timestamp";
	if (empty($flag)) $flag="ASC";
	$flag=strtoupper($flag);
	
	$c=count($a);
	if ($c>0){
		/*
			Strategy:
			First, we'll create an "index" array.
			Then, we'll use sort() on that array, 
			and use that to sort the main array.
		*/

                
                // create "index" array
		$index=array();
		reset($a);
		while (list($key, $val)=each($a)){
			$data=$a[$key]->$field;
			if (is_string($data)) $data=strtoupper(str_replace("\"", "", $data));
			$index[$key]=$data;
		}
		
		// sort index
		$i=0;
		if ($flag=="ASC") asort($index);
		else arsort($index);
		
		// form new array based on index 
		$result=array();
		reset($index);
		while (list($key, $val)=each($index)){
			$result[$i]=$a[$key];
			$i++;
		}
	}
	
	return $result;
}

function pop3_iil_C_Expunge(&$conn, $mailbox){
	return 0;
}

function pop3_iil_C_Flag(&$conn, $mailbox, $messages, $flag){
	return 0;
}

function pop3_iil_C_Delete(&$conn, $mailbox, $messages){
	$fp = $conn->fp;

	$c = 0;
	if (strpos($messages, ":")!==false){
		$a = explode(":", $messages);
		$start = $a[0];
		$end = $a[1];
		for ($i=$start;$i<=$end;$i++) $messages .= (empty($messages)?"":",").$i;
	}
	$message_list = explode(",", $messages);
	while ( list($key, $val) = each($message_list) ){
		fputs($fp, "DELE $val\r\n");
		$line = pop3_iil_ReadLine($fp, 300);
		if ($line[0]=="+"){
			$c++;
		}
	}
	
	//disconnect and reconnect to expunge
	pop3_iil_Close($conn);
	$conn = pop3_iil_Connect($conn->host, $conn->login, $conn->password);
	
	return $c;
}

function pop3_iil_C_Undelete(&$conn, $mailbox, $messages){
	return -1;
}

function pop3_iil_C_Unseen(&$conn, $mailbox, $messages){
	return -1;
}

function pop3_iil_C_Copy(&$conn, $messages, $from, $to){
	return 0;
}

function pop3_iil_FormatSearchDate($month, $day, $year){
	$months=array(
			1=>"Jan", 2=>"Feb", 3=>"Mar", 4=>"Apr", 
			5=>"May", 6=>"Jun", 7=>"Jul", 8=>"Aug", 
			9=>"Sep", 10=>"Oct", 11=>"Nov", 12=>"Dec"
			);
	return $day."-".$months[$month]."-".$year;
}

function pop3_iil_C_Search(&$conn, $folder, $criteria){
	return false;
}

function pop3_iil_C_Move(&$conn, $messages, $from, $to){
	return 0;
}

function pop3_iil_C_GetHierarchyDelimiter(&$conn){
	return "/";
}

function pop3_iil_C_ListMailboxes(&$conn, $ref, $mailbox){
	return array("INBOX");
}

function pop3_iil_ActionPrintBody($line){
	echo chop($line)."\n"; flush();
	return "";
}

function pop3_iil_ActionFetchBody($line){
	return chop($line)."\n";
}

function pop3_iil_ActionBase64Decode($line){
	echo base64_decode(chop($line)); flush();
	return "";
}

function pop3_iil_ActionFetchHeader($line){
	return "";
}

function pop3_iil_ClearCache($login, $host){
	$cacheDir = "../cache";
	if (!is_dir($cacheDir)) $conn->errorNum = -2;
	else{
		$cacheDir = $cacheDir."/".$login.".".$host;
		if (!is_dir($cacheDir)) mkdir($cacheDir, 0700);
	}
	if (is_dir($cacheDir)){
		if ($handle = opendir($cacheDir)) {
			while (false !== ($file = readdir($handle))) { 
				if ($file != "." && $file != "..") { 
					$file_path = $cacheDir."/".$file;
					unlink($file_path);
				} 
			}
			closedir($handle); 
		}
	}	
}

function pop3_iil_C_OpenMessage(&$conn, $id){
	/*
		POST-CONDITIONS:
			TRUE: if cache file has been opened
			FALSE: if cache file is not open
			$conn->cacheMode:
				x: failed
				w: open cache for writing
				r: cache opened for reading
	*/

	
	$conn->messageID = pop3_iil_F_GetMessageID($conn->fp, $id);
	$messageID = $conn->messageID;
	
	$conn->errorNum = 0;
	$conn->cacheMode = "x";
	if (!empty($messageID)){
		$cacheDir = "../cache";
		if (!is_dir($cacheDir)) $conn->errorNum = -2;
		else{
			$cacheDir = $cacheDir."/".$conn->login.".".$conn->host;
			if (!is_dir($cacheDir)) mkdir($cacheDir, 0700);
		}
		if (is_dir($cacheDir)){
			$cachePath = $cacheDir."/".urlencode($messageID);
			if (is_file($cachePath)) $mode = "r";
			else $mode = "w";
			
			$conn->cacheFP = fopen($cachePath, $mode);
			if ($conn->cacheFP){
				$conn->cacheMode = $mode;
				return true;
			}else{
				$conn->errorNum = -3;
				$conn->error = "Couldn't open cache for reading";
			}
		}else{
			$conn->errorNum = -2;
			$conn->error = "Invalid cache directory";
		}
	}else{
		$conn->errorNum = -1;
		$conn->error = "Invalid messageID";
	}
	return false;
}

function pop3_iil_C_CloseMessage(&$conn){
	if (($conn->cacheMode=="r") || ($conn->cacheMode=="w")) fclose($conn->cacheFP);
	$conn->cacheMode = "x";
	$conn->messageID = "";
}

function pop3_iil_C_FetchBodyPart(&$conn, $boundary, &$last_line, $the_part, &$part, $action, $bytes_total, &$bytes_read){
	if ($the_part==0) $the_part="";
	$original_boundary = $boundary; 
	$raw_header = "";
	$raw_text = "";
	
	if ($conn->cacheMode=="r") $fp = $conn->cacheFP;
	else $fp = $conn->fp;

	// read headers from file
	$lines = array();
	$count = 0;
	do{
		$line = pop3_iil_C_ReadLine($conn);
		$bytes_read+=strlen($line);
		$raw_header .= $line;
		$line = chop($line);
		if (!empty($line)){
			$c = 0;
			if (ord($line[0]) <= 32) $lines[$count].=" ".trim($line);
			else{
				$count++;
				$lines[$count] = $line;
			}
		}
	}while(!empty($line));
	if ((strcmp($part, $the_part)==0)&&(strcmp($action, "FetchHeader")==0)) $str=$raw_header;
	

	// parse header into associative array
	$header = pop3_iil_ContentHeaderArray($lines);


	// generate bodystructure string(s)
	if (strcasecmp($header["content-type"]["major"], "multipart")==0){
		
		$params = $header["content-type"]["parameters"];
		while ( list($k, $v) = each($params) ) if (strcasecmp($v, "\"boundary\"")==0) $boundary = "--".str_replace("\"","",$params[$k+1]);
		do{
			$line = pop3_iil_C_ReadLine($conn);
			$bytes_read+=strlen($line);
		}while(!pop3_iil_StartsWith($line, $boundary));

		//parse body parts
		$part_num = 0;
		do{
			$part_num++;
			$next_part = $part.(!empty($part)?".":"").$part_num;
			$str .= pop3_iil_C_FetchBodyPart($conn, $boundary, $last_line, $the_part, $next_part, $action, $bytes_total, $bytes_read);
			$end = ((strlen($last_line) - strlen($boundary)) > 0);
		}while((!$end) && (!feof($fp))&&(chop($last_line)!="."));

		//read up to next message boundary
		do{
			$line = pop3_iil_C_ReadLine($conn);
			$bytes_read += strlen($line);
			$end = (pop3_iil_StartsWith($line, $original_boundary));
		}while((!$end)&&(!feof($fp))&&(chop($line)!="."));
		$last_line = chop($line);
	}else{
		// read actual data

		if (strcmp($part, $the_part)==0){
			$this_is_it=ture;
			$handler = "pop3_iil_Action".$action;
		}else $this_is_it = false;
		do{
			$line = pop3_iil_C_ReadLine($conn);
			$bytes_read += strlen($line);
			if (($this_is_it)&&(!pop3_iil_StartsWith($line, $boundary))&&(chop($line)!=".")) $str.=$handler($line);
			$line = chop($line);

		}while((!pop3_iil_StartsWith($line, $boundary)) && ((!feof($fp))&&($line!=".")));
		$last_line = $line;
	}
	


	return $str;
}

function pop3_iil_C_HandlePartBody(&$conn, $id, $part, $action){
		
	pop3_iil_C_OpenMessage($conn, $id);



	if (($conn->cacheMode=="x") || ($conn->cacheMode=="w")){
		$fp = $conn->fp;
		fputs($fp, "RETR $id\r\n");
		$line = fgets($fp, 100);
		if ($line[0]!="+"){
			$conn->errorNum = -10;
			$conn->error = "POP3 error:".$line;
		}
	}


	if ($conn->fp){
		$result =  pop3_iil_C_FetchBodyPart($conn, "", $line, $part, $part_blah, $action, $total_size, $bytes);
	}else{
		$conn->error = "Bad fp";
	}
	pop3_iil_C_CloseMessage($conn);
	
	return $result;
}

function pop3_iil_C_FetchPartBody(&$conn, $mailbox, $id, $part){
	return pop3_iil_C_HandlePartBody($conn, $id, $part, "FetchBody");
}

function pop3_iil_C_PrintPartBody(&$conn, $mailbox, $id, $part){
	return pop3_iil_C_HandlePartBody($conn, $id, $part, "PrintBody");
}

function pop3_iil_C_PrintBase64Body(&$conn, $mailbox, $id, $part){
	return pop3_iil_C_HandlePartBody($conn, $id, $part, "Base64Decode");
}

function pop3_iil_C_FetchPartHeader(&$conn, $mailbox, $id, $part){
	return pop3_iil_C_HandlePartBody($conn, $id, $part, "FetchHeader");
}

function pop3_iil_C_CreateFolder(&$conn, $folder){
	return false;
}

function pop3_iil_C_RenameFolder(&$conn, $from, $to){
	return false;
}

function pop3_iil_C_DeleteFolder(&$conn, $folder){
	return false;
}

function pop3_iil_C_Append(&$conn, $folder, $message){
	return false;
}

function pop3_iil_ReadHeader($fp){
	$lines = array();
	$c = 0;
	do{
		$line = chop(pop3_iil_ReadLine($fp, 300));
		if (!empty($line)){
			if (ord($line[0]) <= 32) $lines[$c].=" ".trim($line);
			else{
				$c++;
				$lines[$c] = $line;
			}
		}
	}while(!empty($line));
	
	return $lines;
}

function pop3_iil_ParseContentHeader($data){
	$parameters = array();

	$pos = strpos($data, ";");
	if ($pos === false){
		//no';'? then no parameters, all we have is main data
		$major_data = $data;
	}else{
		//every thing before first ';' is main data
		$major_data = substr($data, 0, $pos);
		$data = substr($data, $pos+1);
		
		//go through parameter list (delimited by ';')
		$parameters_a = explode(";", $data);
		while ( list($key, $val) = each($parameters_a) ){
			// split param name from param data
			$val = trim(chop($val));
			$eqpos = strpos($val, "=");
			$p_field = substr($val, 0, $eqpos);
			$p_data = substr($val, $eqpos+1);
			$field = trim(chop($p_field));
			$p_data = trim(chop($p_data));
			// add quotes
			if ($p_data[0]!="\"") $p_data = "\"".$p_data."\"";
			$p_field = "\"".$p_field."\"";
			// add to array
			array_push($parameters, $p_field);
			array_push($parameters, $p_data);
		}
	}
	$result["data"] = trim(chop($major_data));
	if (count($parameters) > 0) $result["parameters"] = $parameters;
	else $result["parameters"] = "NIL";
	
	return $result;
}

function pop3_iil_ContentHeaderArray($lines){
	$num_lines = count($lines);
	//initialize header variables with default (fall back) values
	$header["content-type"]["major"] = "text";
	$header["content-type"]["minor"] = "plain";
	$header["content-transfer-encoding"]["data"] = "8bit";
	while ( list($key, $line) = each($lines) ){
		list($field, $data) = pop3_iil_SplitHeaderLine($line);
		// is this a content header?
		if (pop3_iil_StartsWith($field, "Content")){
			$field = strtolower($field);
			// parse line, add "data" and "parameters" to header[]
			$header[$field] = pop3_iil_ParseContentHeader($data);
			// need some special care for "content-type" header line
			if (strcasecmp($field, "content-type")==0){
				$typeStr = $header["content-type"]["data"];
				//split major and minor content types
				$slashPos = strpos($typeStr,"/");
				$major_type = substr($typeStr, 0, $slashPos);
				$minor_type = substr($typeStr, $slashPos+1);
				$header["content-type"]["major"] = strtolower($major_type);
				$header["content-type"]["minor"] = strtolower($minor_type);
			}
		}
	}
	return $header;
}

function pop3_iil_C_ReadNParse($conn, $boundary, &$last_line){
	$original_boundary = $boundary; 
	
	if ($conn->cacheMode=="r") $fp = $conn->cacheFP;
	else $fp = $conn->fp;

	// read headers from file
	$lines = pop3_iil_ReadHeader($fp);
	if (count($lines) == 0) return "";
	if ($conn->cacheMode=="w") fputs($conn->cacheFP, implode("\n", $lines)."\n\n");
		
	// parse header into associative array
	$header = pop3_iil_ContentHeaderArray($lines);
	
	// generate bodystructure string(s)
	if (strcasecmp($header["content-type"]["major"], "multipart")==0){
		$params = $header["content-type"]["parameters"];
		while ( list($k, $v) = each($params) ) if (strcasecmp($v, "\"boundary\"")==0) $boundary = "--".str_replace("\"","",$params[$k+1]);
		do{
			$line = pop3_iil_C_ReadLine($conn);
		}while(!pop3_iil_StartsWith($line, $boundary));
		$str = "(";
		//parse body parts
		do{
			$str .= pop3_iil_C_ReadNParse($conn, $boundary, $last_line);
			$end = ((strlen($last_line) - strlen($boundary)) > 0);
		}while((!$end) && (!feof($fp))&&($line!="."));
		$str .=" \"".$header["content-type"]["minor"]."\" (".implode(" ", $params).") NIL NIL)";
		//read up to next message boundary
		do{
			$line = pop3_iil_C_ReadLine($conn);
			$end = (pop3_iil_StartsWith($line, $original_boundary));
		}while((!$end)&&(!feof($fp))&&(chop($line)!="."));
		$last_line = chop($line);
	}else{
		// read actual data
		$content_size = 0;
		$num_lines = 0;
		do{
			$line = pop3_iil_C_ReadLine($conn);
			$content_size += strlen($line);
			$num_lines++;
			$line = chop($line);
		}while((!pop3_iil_StartsWith($line, $boundary)) && ((!feof($fp))&&($line!=".")));
		$last_line = $line;
				
		// generate bodystructure string
		$str = "(";
		$str .= "\"".$header["content-type"]["major"]."\" ";
		$str .= "\"".$header["content-type"]["minor"]."\" ";
		if ((is_array($header["content-type"]["parameters"]))&&(count($header["content-type"]["parameters"]) > 0))
			$str .="(".implode(" ", $header["content-type"]["parameters"]).") ";
		else
			$str .= "NIL ";
		$str .= "NIL ";
		$str .= "NIL ";
		$str .= "\"".$header["content-transfer-encoding"]["data"]."\" ";
		$str .= $content_size." ";
		if (strcasecmp($header["content-type"]["major"], "text")==0)
			$str .= $num_lines." ";
		$str .= "NIL ";
		if (!empty($header["content-disposition"]["data"])){
			$param_a = $header["content-disposition"]["parameters"];
			$str .= "(\"".$header["content-disposition"]["data"]."\" ";
			if ((is_array($param_a)) && (count($param_a) > 0))
				$str .="(".implode(" ", $param_a).")";
			else $str .="NIL";
			$str .= ") ";
		}else $str .= "NIL ";
		$str .= "NIL ";
		$str = substr($str, 0, strlen($str)-1);
		$str .= ")";
	}
	
	return $str;
}

function pop3_iil_C_FetchStructureString(&$conn, $folder, $id){
	$fp = $conn->fp;
		
	pop3_iil_C_OpenMessage($conn,$id);
	
	if (($conn->cacheMode=="x") || ($conn->cacheMode=="w")){
		fputs($fp, "RETR $id\r\n");
		$line = fgets($fp, 100);
		if ($line[0]!="+"){
			$conn->errorNum = -10;
			$conn->error = "POP3 error:".$line;
		}
	}

	if ($conn->fp){
		$str =  pop3_iil_C_ReadNParse($conn, "", $line);
	}
	pop3_iil_C_CloseMessage($conn);
	
	return $str;
}

function pop3_iil_C_PrintSource(&$conn, $folder, $id, $part){
	pop3_iil_C_OpenMessage($conn,$id);
	
	if ($conn->cacheMode=="r") $fp = $conn->cacheFP;
	else $fp = $conn->fp;
	
	if (($conn->cacheMode=="x") || ($conn->cacheMode=="w")){
		fputs($fp, "RETR $id\r\n");
		$line = fgets($fp, 100);
		if ($line[0]!="+"){
			$conn->errorNum = -10;
			$conn->error = "POP3 error:".$line;
		}
	}

	if ($fp){
		do{
			$line = pop3_iil_ReadLine($fp, 300);
			echo $line;
		}while((chop($line)!=".")&&(!feof($fp)));
	}
	pop3_iil_C_CloseMessage($conn);
}

?>
